Index: trunk/src/lib/network/synchronizeable.h
===================================================================
--- trunk/src/lib/network/synchronizeable.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable.h	(revision 9406)
@@ -1,5 +1,5 @@
 /*!
  * @file synchronizeable.h
-    \brief interface for all classes that have to be synchronized
+ * @brief interface for all classes that have to be synchronized
  */
 
@@ -8,8 +8,5 @@
 
 #include "base_object.h"
-#include "netdefs.h"
-#include "converter.h"
-#include "vector.h"
-#include "quaternion.h"
+
 #include "synchronizeable_var/synchronizeable_var.h"
 #include "synchronizeable_var/synchronizeable_vector.h"
@@ -20,11 +17,9 @@
 #include "synchronizeable_var/synchronizeable_bool.h"
 #include "synchronizeable_var/synchronizeable_uint.h"
-
+#include "synchronizeable_var/synchronizeable_ip.h"
 
 #include <vector>
 #include <list>
 
-//State constants: They have to be of the form 2^n
-#define STATE_SERVER 1
 
 struct StateHistoryEntry
@@ -51,7 +46,4 @@
     virtual ~Synchronizeable();
 
-    void setIsServer( bool isServer );
-    bool isServer();
-
     virtual void varChangeHandler( std::list<int> & id );
 
@@ -61,5 +53,5 @@
     virtual void handleSentState( int userId, int stateId, int fromStateId );
     virtual void handleRecvState( int userId, int stateId, int fromStateId );
-    
+
     void registerVar( SynchronizeableVar * var );
     int registerVarId( SynchronizeableVar * var );
@@ -82,5 +74,5 @@
   protected:
     NetworkStream*    networkStream;  //!< reference network stream we are connected to
-    int               state;
+
 
   private:
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_bool.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_bool.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_bool.cc	(revision 9406)
@@ -16,4 +16,5 @@
 
 #include "synchronizeable_bool.h"
+#include <cassert>
 
 
@@ -44,7 +45,7 @@
 {
   assert( maxLength >= 1 );
-  
+
   buf[0] = ( *vPtrIn ) ? 1 : 0;
-  
+
   return 1;
 }
@@ -59,11 +60,11 @@
 {
   assert( maxLength >= 1 );
-  
+
   bool oldVal = *vPtrOut;
-  
+
   *vPtrOut = buf[0] != 0;
-  
+
   setHasChanged( oldVal != *vPtrOut );
-  
+
   return 1;
 }
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_bool.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_bool.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_bool.h	(revision 9406)
@@ -2,20 +2,20 @@
  * @file synchronizeable_int.h
  * @brief Definition of SynchronizeableInt
-*/
-
-#include "synchronizeable_var/synchronizeable_var.h"
+ */
 
 #ifndef _SYNCHRONIZEABLE_BOOL_H
 #define _SYNCHRONIZEABLE_BOOL_H
 
+#include "synchronizeable_var.h"
+
 class SynchronizeableBool : public SynchronizeableVar {
 
   public:
-    SynchronizeableBool( bool * ptrIn, bool * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableBool( bool * ptrIn, bool * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableBool();
-    
+
     virtual int writeToBuf( byte * buf, int maxLength );
     virtual int readFromBuf( byte * buf, int maxLength );
-    
+
     /**
      * check if writeToBuf will return the same size every time
@@ -23,7 +23,7 @@
      */
     virtual bool hasStaticSize(){ return true; };
-    
+
     virtual void debug();
-    
+
   private:
     bool * vPtrIn;       //!< pointer to data (read)
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_float.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_float.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_float.cc	(revision 9406)
@@ -17,4 +17,5 @@
 #include "synchronizeable_float.h"
 #include "converter.h"
+#include <cassert>
 
 
@@ -46,7 +47,7 @@
 {
   int res = Converter::floatToByteArray( *vPtrIn, buf, maxLength );
-  
+
   assert( res == FLOATSIZE );
-  
+
   return res;
 }
@@ -61,13 +62,13 @@
 {
   assert( maxLength >= FLOATSIZE );
-  
+
   float oldVal = *vPtrOut;
-  
+
   int res = Converter::byteArrayToFloat( buf, vPtrOut );
-  
+
   setHasChanged( oldVal != *vPtrOut );
-  
+
   assert( res == FLOATSIZE );
-  
+
   return res;
 }
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_float.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_float.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_float.h	(revision 9406)
@@ -2,20 +2,21 @@
  * @file synchronizeable_float.h
  * @brief Definition of SynchronizeableFloat
-*/
+ */
 
-#include "synchronizeable_var/synchronizeable_var.h"
 
 #ifndef _SYNCHRONIZEABLE_FLOAT_H
 #define _SYNCHRONIZEABLE_FLOAT_H
 
+#include "synchronizeable_var.h"
+
 class SynchronizeableFloat : public SynchronizeableVar {
 
   public:
-    SynchronizeableFloat( float * ptrIn, float * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableFloat( float * ptrIn, float * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableFloat();
-    
+
     virtual int writeToBuf( byte * buf, int maxLength );
     virtual int readFromBuf( byte * buf, int maxLength );
-        
+
     /**
      * check if writeToBuf will return the same size every time
@@ -23,7 +24,7 @@
      */
     virtual bool hasStaticSize(){ return true; };
-    
+
     virtual void debug();
-    
+
   private:
     float * vPtrIn;       //!< pointer to data (read)
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_int.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_int.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_int.cc	(revision 9406)
@@ -18,4 +18,5 @@
 #include "converter.h"
 
+#include <cassert>
 
 /**
@@ -46,7 +47,7 @@
 {
   int res = Converter::intToByteArray( *vPtrIn, buf, maxLength );
-  
+
   assert( res == INTSIZE );
-  
+
   return res;
 }
@@ -61,13 +62,13 @@
 {
   assert( maxLength >= INTSIZE );
-  
+
   int oldVal = *vPtrOut;
-  
+
   int res = Converter::byteArrayToInt( buf, vPtrOut );
-  
+
   setHasChanged( oldVal != *vPtrOut );
-  
+
   assert( res == INTSIZE );
-  
+
   return res;
 }
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_int.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_int.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_int.h	(revision 9406)
@@ -4,18 +4,19 @@
 */
 
-#include "synchronizeable_var/synchronizeable_var.h"
 
 #ifndef _SYNCHRONIZEABLE_INT_H
 #define _SYNCHRONIZEABLE_INT_H
 
+#include "synchronizeable_var.h"
+
 class SynchronizeableInt : public SynchronizeableVar {
 
   public:
-    SynchronizeableInt( int * ptrIn, int * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableInt( int * ptrIn, int * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableInt();
-    
+
     virtual int writeToBuf( byte * buf, int maxLength );
     virtual int readFromBuf( byte * buf, int maxLength );
-    
+
     /**
      * check if writeToBuf will return the same size every time
@@ -23,7 +24,7 @@
      */
     virtual bool hasStaticSize(){ return true; };
-    
+
     virtual void debug();
-    
+
   protected:
     int * vPtrIn;       //!< pointer to data (read)
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_ip.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_ip.cc	(revision 9406)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_ip.cc	(revision 9406)
@@ -0,0 +1,108 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+
+#include "synchronizeable_ip.h"
+#include "converter.h"
+#include "netdefs.h"
+#include "ip.h"
+#include <cassert>
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+SynchronizeableIP::SynchronizeableIP( IP * ptrIn, IP * ptrOut, std::string name, int permission, int priority) : SynchronizeableVar( ptrIn, ptrOut, name, 2*INTSIZE, permission, priority )
+{
+  this->vPtrIn = ptrIn;
+  this->vPtrOut = ptrOut;
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableIP::~SynchronizeableIP ()
+{
+}
+
+/**
+ * write var data to byte buffer
+ * @param buf pointer to write to
+ * @param maxLength writeToBuf will not write more than maxLength bytes
+ * @return number bytes written
+ */
+int SynchronizeableIP::writeToBuf( byte * buf, int maxLength )
+{
+  int n = 0;
+  int res;
+
+  res = Converter::intToByteArray( (int)vPtrIn->host(), buf, maxLength );
+  assert(res > 0);
+  n += res;
+
+
+  res = Converter::intToByteArray( (int)vPtrIn->port(), buf + n, maxLength);
+  assert(res > 0);
+  n += res;
+
+  assert( 2 * INTSIZE == n);
+
+  return n;
+}
+
+/**
+ * read var data from byte buffer
+ * @param buf pointer to read from
+ * @param maxLength readFromBuf will not read more than maxLength bytes
+ * @return number bytes read
+ */
+int SynchronizeableIP::readFromBuf( byte * buf, int maxLength )
+{
+  assert( maxLength >= 2 * INTSIZE);
+
+  int host, port;
+
+  int res;
+  int n = 0;
+
+  IP oldVal = *vPtrOut;
+
+  res = Converter::byteArrayToInt( buf + n, &host);
+  assert( res > 0);
+  n += res;
+
+
+  res = Converter::byteArrayToInt( buf + n, &port);
+  assert( res > 0);
+  n += res;
+
+  *this->vPtrOut = IP(host, port);
+
+  this->setHasChanged( *this->vPtrOut != oldVal);
+
+  assert( n == 2 * INTSIZE);
+
+  return n;
+}
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableIP::SynchronizeableIP::debug( )
+{
+  printf("SYNCHRONIZEABLE_VAR: %s IN: %i, %i OUT: %i, %i\n", name.c_str(), vPtrIn->host(), vPtrIn->port(), vPtrOut->host(), vPtrOut->port());
+}
+
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_ip.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_ip.h	(revision 9406)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_ip.h	(revision 9406)
@@ -0,0 +1,38 @@
+/*!
+ * @file synchronizeable_ip.h
+ * @brief Definition of SynchronizeableIP
+*/
+
+
+#ifndef _SYNCHRONIZEABLE_IP_H
+#define _SYNCHRONIZEABLE_IP_H
+
+#include "synchronizeable_var.h"
+
+class IP;
+
+class SynchronizeableIP : public SynchronizeableVar {
+
+  public:
+    SynchronizeableIP( IP *ptrIn, IP * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
+    virtual ~SynchronizeableIP();
+
+    virtual int writeToBuf( byte * buf, int maxLength );
+    virtual int readFromBuf( byte * buf, int maxLength );
+
+    /**
+     * check if writeToBuf will return the same size every time
+     * @return true if same size every time
+     */
+    virtual bool hasStaticSize(){ return true; }
+
+    virtual void debug();
+
+
+  private:
+    IP * vPtrIn;       //!< pointer to data (read)
+    IP * vPtrOut;      //!< pointer to data (write)
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_quaternion.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_quaternion.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_quaternion.cc	(revision 9406)
@@ -17,4 +17,5 @@
 #include "synchronizeable_quaternion.h"
 #include "converter.h"
+#include <cassert>
 
 
@@ -98,9 +99,9 @@
   assert( res > 0 );
   n += res;
-  
+
   Quaternion oldVal = *vPtrOut;
 
   *vPtrOut = Quaternion( Vector(x, y, z), w );
-  
+
   setHasChanged( ! ( oldVal == *vPtrOut ) );
 
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_quaternion.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_quaternion.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_quaternion.h	(revision 9406)
@@ -4,8 +4,8 @@
 */
 
-#include "synchronizeable_var/synchronizeable_var.h"
-
 #ifndef _SYNCHRONIZEABLE_QUATERNION_H
 #define _SYNCHRONIZEABLE_QUATERNION_H
+
+#include "synchronizeable_var.h"
 
 #include "quaternion.h"
@@ -14,10 +14,10 @@
 
   public:
-    SynchronizeableQuaternion( Quaternion * ptrIn, Quaternion * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableQuaternion( Quaternion * ptrIn, Quaternion * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableQuaternion();
-    
+
     virtual int writeToBuf( byte * buf, int maxLength );
     virtual int readFromBuf( byte * buf, int maxLength );
-        
+
     /**
      * check if writeToBuf will return the same size every time
@@ -25,7 +25,7 @@
      */
     virtual bool hasStaticSize(){ return true; };
-    
+
     virtual void debug();
-    
+
   private:
     Quaternion * vPtrIn;       //!< pointer to data (read)
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_string.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_string.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_string.cc	(revision 9406)
@@ -17,4 +17,5 @@
 #include "synchronizeable_string.h"
 #include "converter.h"
+#include <cassert>
 
 
@@ -46,9 +47,14 @@
 {
   int res = Converter::stringToByteArray( *vPtrIn, buf, maxLength );
-  
+
   assert( res > 0 );
   assert( res == vPtrIn->length()+INTSIZE );
-  
+
   return res;
+}
+
+int SynchronizeableString::getSize()
+{
+   return vPtrIn->length()+INTSIZE;
 }
 
@@ -62,9 +68,9 @@
 {
   std::string oldVal = *vPtrOut;
-      
+
   int res = Converter::byteArrayToString( buf, *vPtrOut, maxLength );
-  
+
   setHasChanged( oldVal != *vPtrOut );
-  
+
   if ( res < 0 )
   {
@@ -72,5 +78,5 @@
   }
   assert( res > 0 );
-  
+
   return res;
 }
@@ -94,9 +100,9 @@
 {
   std::string t;
-  
+
   int res = Converter::byteArrayToString( buf, t, maxLength );
-  
+
   assert( res > 0 );
-  
+
   return res;
 }
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_string.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_string.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_string.h	(revision 9406)
@@ -4,9 +4,8 @@
 */
 
-#include "synchronizeable_var/synchronizeable_var.h"
-#include "converter.h"
-
 #ifndef _SYNCHRONIZEABLE_STRING_H
 #define _SYNCHRONIZEABLE_STRING_H
+
+#include "synchronizeable_var.h"
 
 #include <string>
@@ -15,11 +14,11 @@
 
   public:
-    SynchronizeableString( std::string * ptrIn, std::string * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableString( std::string * ptrIn, std::string * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableString();
-    
+
     virtual int writeToBuf( byte * buf, int maxLength );
     virtual int readFromBuf( byte * buf, int maxLength );
-    
-        
+
+
     /**
      * check if writeToBuf will return the same size every time
@@ -27,11 +26,11 @@
      */
     virtual bool hasStaticSize(){ return false; };
-    
-    virtual int getSize(){ return vPtrIn->length()+INTSIZE; }
-    
+
+    virtual int getSize();
+
     virtual int getSizeFromBuf( byte * buf, int maxLength );
-    
+
     virtual void debug();
-    
+
   private:
     std::string * vPtrIn;       //!< pointer to data (read)
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.h	(revision 9406)
@@ -4,15 +4,16 @@
 */
 
-#include "synchronizeable_var/synchronizeable_int.h"
 
 #ifndef _SYNCHRONIZEABLE_UINT_H
 #define _SYNCHRONIZEABLE_UINT_H
 
+#include "synchronizeable_int.h"
+
 class SynchronizeableUInt : public SynchronizeableInt {
 
   public:
-    SynchronizeableUInt( unsigned int * ptrIn, unsigned int * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableUInt( unsigned int * ptrIn, unsigned int * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableUInt();
-    
+
     virtual void debug();
 
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_var.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_var.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_var.cc	(revision 9406)
@@ -16,5 +16,6 @@
 
 #include "synchronizeable_var.h"
-
+#include "netdefs.h"
+#include <cassert>
 
 
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 9406)
@@ -7,12 +7,12 @@
 #define _SYNCHRONIZEABLE_VAR_H
 
+#include "nettypes.h"
 #include <string>
-#include "netdefs.h"
-#include <assert.h>
 
 enum {
-  PERMISSION_SERVER = 1,
-  PERMISSION_OWNER  = 2,
-  PERMISSION_ALL    = 4
+  PERMISSION_MASTER_SERVER = 1,
+  PERMISSION_PROXY_SERVER  = 2,
+  PERMISSION_OWNER         = 4,
+  PERMISSION_ALL           = 8
 };
 
@@ -20,5 +20,5 @@
 
   public:
-    SynchronizeableVar( void * ptrIn, void * ptrOut, std::string name, int length, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableVar( void * ptrIn, void * ptrOut, std::string name, int length, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableVar();
 
@@ -28,6 +28,6 @@
      */
     inline bool beWatched(){ return this->bWatched; }
-    
-    /** 
+
+    /**
      * set flag if synchronizeable wants to be informed on changes
      */
@@ -96,5 +96,5 @@
      */
     inline void resetPriority() { this->priority = this->realPriority; }
-    
+
     /**
      * reads actual size from buffer. this is used when size is not constant
@@ -104,5 +104,5 @@
      */
     virtual inline int getSizeFromBuf( byte * buf, int maxLength ){ return this->getSize(); }
-    
+
     /**
      * set variable id
@@ -110,11 +110,11 @@
      */
     inline void setVarId( int id ){ this->varId = id; }
-    
-    /** 
+
+    /**
      * get variable id
      * @return variable id
      */
     inline int getVarId(){ return varId; }
-    
+
     /**
      * set hasChanged
@@ -122,11 +122,11 @@
      */
     inline void setHasChanged( bool changed ){ this->changed = changed; }
-    
-    /** 
+
+    /**
      * get hasChanged
      * @return variable id
      */
     inline bool getHasChanged(){ return changed; }
-    
+
     /**
      * print out variable value
@@ -137,10 +137,10 @@
   private:
     bool bWatched;      //!< true if synchronizeable wants to be informed on changes
-    
+
     int permission;     //!< who is allowed to change this var
     int priority;       //!< priority assigned to var
     int realPriority;   //!< priority assigned to var, increased every time not sent
     int varId;          //!< id to identify varables
-    
+
     bool changed;       //!< true if last readFromBuf changed anything
 
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.cc
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 9406)
@@ -17,4 +17,5 @@
 #include "synchronizeable_vector.h"
 #include "converter.h"
+#include <cassert>
 
 
@@ -79,5 +80,5 @@
   int res;
   int n = 0;
-  
+
   Vector oldVec = *vPtrOut;
 
@@ -95,5 +96,5 @@
 
   *vPtrOut = Vector( x, y, z );
-  
+
   setHasChanged( !(*vPtrOut == oldVec) );
 
Index: trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.h
===================================================================
--- trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 9391)
+++ trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 9406)
@@ -4,8 +4,8 @@
 */
 
-#include "synchronizeable_var/synchronizeable_var.h"
-
 #ifndef _SYNCHRONIZEABLE_VECTOR_H
 #define _SYNCHRONIZEABLE_VECTOR_H
+
+#include "synchronizeable_var.h"
 
 #include "vector.h"
@@ -14,10 +14,10 @@
 
   public:
-    SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableVector();
-    
+
     virtual int writeToBuf( byte * buf, int maxLength );
     virtual int readFromBuf( byte * buf, int maxLength );
-    
+
     /**
      * check if writeToBuf will return the same size every time
@@ -25,7 +25,7 @@
      */
     virtual bool hasStaticSize(){ return true; }
-    
+
     virtual void debug();
-    
+
   private:
     Vector * vPtrIn;       //!< pointer to data (read)
Index: trunk/src/lib/network/tcp_socket.h
===================================================================
--- trunk/src/lib/network/tcp_socket.h	(revision 9391)
+++ trunk/src/lib/network/tcp_socket.h	(revision 9406)
@@ -1,5 +1,5 @@
 /*!
- * @file network_socket.h
-  *  Main interface for the network module. Manages all the modules
+ * @file tcp_socket.h
+  *  tcp socket network interface
 
 */
@@ -16,5 +16,5 @@
 #define _INCOMING_BUFFER_SIZE 2024000
 #define _OUTGOING_BUFFER_SIZE 2024000
-#define _LOCAL_BUFFER_SIZE 1024
+#define _LOCAL_BUFFER_SIZE 2048
 //sleep if incoming buffer is full
 #define _MSECONDS_SLEEP_FULL_BUFFER 10
@@ -47,6 +47,8 @@
 
     virtual void connectToServer( std::string host, int port );
-    
+
     virtual void disconnectServer();
+    virtual void reconnectToServer( std::string host, int port);
+    virtual void reconnectToServerSoft( std::string host, int port);
 
     virtual bool writePacket(byte * data, int length);
Index: trunk/src/lib/network/udp_socket.cc
===================================================================
--- trunk/src/lib/network/udp_socket.cc	(revision 9391)
+++ trunk/src/lib/network/udp_socket.cc	(revision 9406)
@@ -74,4 +74,5 @@
 {
   this->init();
+  this->ip = ip;
   this->serverSocket = serverSocket;
   this->userId = userId;
@@ -105,11 +106,9 @@
   assert( serverSocket == NULL );
 
-  IPaddress ip;
-  
   this->randomByte = generateNewRandomByte();
 
   PRINTF(0)("connect to server %s on port %d\n", host.c_str(), port);
 
-  if ( SDLNet_ResolveHost( &ip, host.c_str(), port ) != 0 )
+  if ( SDLNet_ResolveHost( &this->ip, host.c_str(), port ) != 0 )
   {
     PRINTF(1)("SDLNet_ResolveHost: %s\n", SDLNet_GetError() );
@@ -126,5 +125,5 @@
   }
 
-  int channel = SDLNet_UDP_Bind(socket, 1, &ip);
+  int channel = SDLNet_UDP_Bind(socket, 1, &this->ip);
   if ( channel == -1 )
   {
@@ -147,5 +146,37 @@
   bOk = false;
   socket = NULL;
-}
+
+  this->ip.host = 0;
+  this->ip.port = 0;
+}
+
+
+/**
+ * reconnects to
+ * @param host new server address
+ * @param port new port number
+ *
+ * this terminates the current connection and starts a new connection to the new server
+ */
+void UdpSocket::reconnectToServer( std::string host, int port)
+{
+  // first disconnect the old server
+  this->disconnectServer();
+
+  // now connect to the new
+  this->connectToServer( host, port);
+}
+
+
+/**
+ * reconnects to
+ * @param host new server address
+ * @param port new port number
+ *
+ * this terminates the current connection and starts a new connection to the new server
+ */
+void UdpSocket::reconnectToServerSoft( std::string host, int port)
+{}
+
 
 /**
@@ -179,5 +210,5 @@
 
     byte udpCmd = 0;
-    
+
     if ( networkPacket.length > 0 )
     {
@@ -189,5 +220,5 @@
     else
       return 0;
-      
+
     if ( !checkRandomByte( networkPacket.data[0] ) )
       return 0;
@@ -198,5 +229,5 @@
       networkPacket.data = NULL;
     }
-    
+
     if ( !checkUdpCmd( udpCmd ) )
       return 0;
@@ -207,5 +238,5 @@
   {
     int numrecv = SDLNet_UDP_Recv( socket, packet);
-    
+
     byte udpCmd = 0;
 
@@ -218,8 +249,8 @@
       else
         return 0;
-            
+
       if ( !checkRandomByte( packet->data[0] ) )
         return 0;
-              
+
       if ( !checkUdpCmd( udpCmd ) )
         return 0;
@@ -283,5 +314,5 @@
     return false;
   }
-  
+
   if ( !this->serverSocket && ( udpCmd & UDPCMD_INVALIDRNDBYTE ) )
   {
@@ -292,5 +323,5 @@
     return false;
   }
-  
+
   return true;
 }
@@ -300,7 +331,7 @@
   srand( SDL_GetTicks() );
   byte res = ( rand() & 0xFC );
-  
+
   PRINTF(0)("generated random byte: %x\n", res);
-  
+
   return res;
 }
Index: trunk/src/lib/network/udp_socket.h
===================================================================
--- trunk/src/lib/network/udp_socket.h	(revision 9391)
+++ trunk/src/lib/network/udp_socket.h	(revision 9406)
@@ -31,25 +31,26 @@
 
     virtual void connectToServer( std::string host, int port );
-    
     virtual void disconnectServer();
 
+    virtual void reconnectToServer( std::string host, int port);
+    virtual void reconnectToServerSoft( std::string host, int port);
+
     virtual bool writePacket(byte * data, int length );
+    virtual int readPacket(byte * data, int maxLength);
 
-    virtual int readPacket(byte * data, int maxLength);
-    
+
   private:
     UdpServerSocket * serverSocket;   //!< will get packets here
     int               userId;         //!< user id used by serverSocket
-    IPaddress         ip;             //!< host,port
     UDPsocket         socket;         //!< socket used to send/recieve
     UDPpacket *       packet;
-    
+
     byte              randomByte;     //!< contains random bytes & 0xFC
-    
+
     bool writeRawPacket( byte * data, int length );
     bool checkUdpCmd( byte udpCmd );
     bool checkRandomByte( byte rndByte );
     byte generateNewRandomByte();
-    
+
     void init();
 
Index: trunk/src/lib/parser/cmdline_parser/cmdline_parser.cc
===================================================================
--- trunk/src/lib/parser/cmdline_parser/cmdline_parser.cc	(revision 9391)
+++ trunk/src/lib/parser/cmdline_parser/cmdline_parser.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "src/lib/util/substring.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/parser/ini_parser/ini_parser.cc
===================================================================
--- trunk/src/lib/parser/ini_parser/ini_parser.cc	(revision 9391)
+++ trunk/src/lib/parser/ini_parser/ini_parser.cc	(revision 9406)
@@ -35,5 +35,5 @@
 #endif
 
-using namespace std;
+
 
 /**
@@ -142,5 +142,5 @@
       if ( (*lineBegin == '#' || *lineBegin == ';'))
       {
-        string newCommenLine = lineBegin;
+        std::string newCommenLine = lineBegin;
         this->commentList.push_back(newCommenLine);
         continue;
@@ -242,4 +242,5 @@
   }
   fclose(stream);
+  return true;
 }
 
Index: trunk/src/lib/parser/preferences/cmd_line_prefs_reader.cc
===================================================================
--- trunk/src/lib/parser/preferences/cmd_line_prefs_reader.cc	(revision 9391)
+++ trunk/src/lib/parser/preferences/cmd_line_prefs_reader.cc	(revision 9406)
@@ -20,5 +20,5 @@
 #include "preferences.h"
 
-using namespace std;
+
 
 RegistredArgs CmdLinePrefsReader::regArgs;
Index: trunk/src/lib/parser/preferences/ini_file_prefs_reader.cc
===================================================================
--- trunk/src/lib/parser/preferences/ini_file_prefs_reader.cc	(revision 9391)
+++ trunk/src/lib/parser/preferences/ini_file_prefs_reader.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "ini_file_prefs_reader.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/particles/box_emitter.cc
===================================================================
--- trunk/src/lib/particles/box_emitter.cc	(revision 9391)
+++ trunk/src/lib/particles/box_emitter.cc	(revision 9406)
@@ -25,5 +25,5 @@
 #include "stdlibincl.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/particles/dot_emitter.cc
===================================================================
--- trunk/src/lib/particles/dot_emitter.cc	(revision 9391)
+++ trunk/src/lib/particles/dot_emitter.cc	(revision 9406)
@@ -24,5 +24,5 @@
 #include "debug.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/particles/dot_particles.cc
===================================================================
--- trunk/src/lib/particles/dot_particles.cc	(revision 9391)
+++ trunk/src/lib/particles/dot_particles.cc	(revision 9406)
@@ -33,5 +33,5 @@
     ->defaultValues("maps/evil-flower.png");
 
-using namespace std;
+
 
 /**
Index: trunk/src/lib/particles/engine/particle_engine.cc
===================================================================
--- trunk/src/lib/particles/engine/particle_engine.cc	(revision 9391)
+++ trunk/src/lib/particles/engine/particle_engine.cc	(revision 9406)
@@ -24,5 +24,5 @@
 #include "util/loading/load_param.h"
 
-using namespace std;
+
 
 /**
Index: trunk/src/lib/particles/model_particles.cc
===================================================================
--- trunk/src/lib/particles/model_particles.cc	(revision 9391)
+++ trunk/src/lib/particles/model_particles.cc	(revision 9406)
@@ -33,5 +33,5 @@
 ->defaultValues("maps/evil-flower.png");
 
-using namespace std;
+
 
 /**
@@ -136,5 +136,5 @@
     }
   else
-    PRINTF(2)("no model loaded onto ParticleSystem-%s\n", this->getName());
+    PRINTF(2)("no model loaded onto ParticleSystem-%s\n", this->getCName());
   glPopAttrib();
 }
Index: trunk/src/lib/particles/particle_emitter.cc
===================================================================
--- trunk/src/lib/particles/particle_emitter.cc	(revision 9391)
+++ trunk/src/lib/particles/particle_emitter.cc	(revision 9406)
@@ -24,5 +24,5 @@
 #include "stdlibincl.h"
 
-using namespace std;
+
 
 /**
@@ -198,5 +198,5 @@
 void ParticleEmitter::debug() const
 {
-  PRINT(0)(" ParticleEmitter %s::%s\n", this->getClassName(), this->getName());
+  PRINT(0)(" ParticleEmitter %s::%s\n", this->getClassCName(), this->getCName());
   PRINT(0)("  EmissionRate: %f, Speed: %f, SpreadAngle: %f\n", this->getEmissionRate(), this->getEmissionVelocity(), this->getSpread());
 }
